
Roll	MACRO
	lea.l		Address2YSpecial+30*\1,a0
	move.b		(a0),d0
	lea.l		Address2YSpecial+30*\1+30,a0
	roxl.b		#1,d0
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	roxl.w		-(a0)
	ENDM



;*********************************************************
gray:
	movem.l	d0-d7/a0-a6,-(a7)	;

	move.l		#$F00*2+8,-(a7)		; size of 2 screen + 8 bytes
	jsr		doorsos::HeapAllocHigh	;
	addq.l		#4,a7			;
	move.w		d0,handle		; saves the handle
	beq		graylib_fail		; if handle == 0, exit

	DEREF		d0,a5			; a5 = adress of the allocated bitplane

;	push.l		#$F00*2+8
;	clr.w		-(a7)
;	push.l		a5
;	jsr		doorsos::memset
;	lea		10(a7),a7
;	memset(a5, 0, 0xf00+8);

	move.l		a5,d0			;
	addq.l		#7,d0			;
	lsr.l		#3,d0			; d0 / 8
;	move.w		d0,table+2*1		; store it in the IO adresses table
;	move.w		d0,table+2*2		; twice

	move.w		#LCD_MEM/8,table+2*1		; store it in the IO adresses table
	move.w		#LCD_MEM/8,table+2*2		; twice

	lsl.l		#3,d0			; d0 * 8
	move.l		d0,plane0		; save it in plane1

	add.l		#$F00,d0			; d0 = adress of the first bitplane
	move.l		d0,plane1		; save it in plane 0

	move.l		BufferPlan1,d0
	lsr.l		#3,d0			; d0 / 8
	move.w		d0,table+2*0		; store it in the table 
	lsl.l		#3,d0
	move.l		d0,BufferPlan1
	


;	move.l		#gray4man,d1		; d1 = adress of the gray 4 int handler
	bsr		installgray		; installs the gray4 int handler

	movem.l	(a7)+,d0-d7/a0-a6	; quits..
	moveq.l	#1,d0			;
	rts


gray4man:
; gray 4 interrupt handler

	move.w		#$2700,sr		; ints off

	add.w		#1,vbl_phase		; vbl_phase++
	and.w		#3,vbl_phase		; 
	bne		int_1_skip		; skip the refresh..

	movem.l		d0/a0,-(a7)		; saves d0/a0
	move.w		phase(pc),d0		; d0 = phase
	lea		table(pc),a0		; a0: IO adresses table
	move.w		0(a0,d0.w),($600010) 	; $600010 = table[phase]
	add.w		#2,d0			; phase += 2
	cmp.w		#2*3,d0			; phase == 6 ?
	bne		no_wrap			; no -> no wrap
	clr.w		d0			; yes -> phase = 0
no_wrap:
	move.w		d0,phase		; save phase

	add.b		#1,scrollVar
	cmp.b		#8,scrollVar
	beq		ScrollABitOr2

	movem.l		(a7)+,d0/a0		; pop regs
	rte


int_1_skip:
	rte


ScrollABitOr2:
	clr.b		scrollVar
	Roll		0
	Roll		1
	Roll		2
	Roll		3
	Roll		4
	movem.l		(a7)+,d0/a0		; pop regs
	rte



gray4man2:					;Other Int (2,3,4,5,6,7)
	rte

installgray:
;input:d1: adress of the grayscale manager
	lea.l		old_int(PC),a1
	move.l		#$64,a0
	move.w		#$0700,d0		;
	trap		#1			; ints off
;	move.l		$64,old_int_1
	move.l		(a0)+,old_int_1		; saves the old int 1 handler
	move.l		(a0)+,(a1)+		;2
	move.l		(a0)+,(a1)+		;3 x
	move.l		(a0)+,(a1)+		;4
	move.l		(a0)+,(a1)+		;5
	move.l		(a0)+,(a1)+		;6
	move.l		(a0)+,(a1)+		;7 x

	bclr.b		#2,$600001		; mem protection off
;	move.l		d1,$64	
	move.l		#$64,a0
	lea.l		new_int(PC),a1
	move.l		(a1)+,(a0)+		; installes the new int 1 handler
	move.l		(a1),(a0)+		;2
	move.l		(a1),(a0)+		;3 x
	move.l		(a1),(a0)+		;4
	move.l		(a1),(a0)+		;5
	move.l		(a1),(a0)+		;6
	move.l		(a1),(a0)+		;7 x


;	move.w		#$00A0,$600016
	bset.b		#2,$600001		; mem prot on
	trap		#1			; ints on
	rts



gray2:
	
	movem.l	d0-d7/a0-a6,-(sp)		; saves regs
;	tst.l		old_int_1		; is gray4 or gray7 enabled ?
;	beq		graylib_fail		; no-> quit
	move.w		#$0700,d0		;
	trap		#1			; ints off
	bclr.b		#2,$600001		; mem protection off
;	move.l		old_int_1,$64	
	lea.l		old_int(PC),a1
	move.l		#$64,a0
	move.l		old_int_1,(a0)+		; restore the old int 1 handler
	move.l		(a1)+,(a0)+		;2	68
	move.l		(a1)+,(a0)+		;3	6C x
	move.l		(a1)+,(a0)+		;4	70
	move.l		(a1)+,(a0)+		;5	74
	move.l		(a1)+,(a0)+		;6	78
	move.l		(a1)+,(a0)+		;7	7C x

;	move.w		#$00B2,$600016
	bset.b		#2,$600001		; mem protection on
	clr.l		old_int_1		; old_int_1 = 0
	clr.w		d0			;
	trap		#1			; ints on
	clr.w		phase			; clear the vars
	clr.w		vbl_phase		; ...
	move.w		#LCD_MEM/8,($600010); restores the base IO adress of the screen ( = $4C00 / 8)

	move.w		handle(pc),-(sp)	; handle of the bitplanes
	jsr		doorsos::HeapFree	; free it
	addq.l		#2,a7			;

	movem.l	(sp)+,d0-d7/a0-a6	; quit..
	clr.l		d0			;
	rts



graylib_fail:
        trap    #4
        movem.l	(sp)+,d0-d7/a0-a6	; quit..
	clr.l		d0			;
	rts





plane0		dc.l	0

plane1		dc.l	0

old_int		ds.l	6

new_int		dc.l	gray4man,gray4man2

old_int_1	dc.l	0
handle		dc.w	0
vbl_phase	dc.w	0
phase		dc.w	0
table		ds.w	6
srTable		ds.w	8
scrollVar	dc.b	0
	EVEN
