        include fglib.h
        include userlib.h
        include doorsos.h

	xdef _library
;	xdef _ti92plus
	xdef _ti89

	xdef engine@0000
	xdef engine@0001	;NbPoints
	xdef engine@0002	;NbFaces
	xdef engine@0003	;Points
	xdef engine@0004	;Faces

;***********************************************************
	include	fglibM.h
	include	engineM.h
	include	Calc3D.asm
	include QuickSort.asm
	include	GrayHandler.asm
;	include	Hexfnct.asm
;***********************************************************


;	include	engine.sdb

;	include	Engine92p.h
	include	Engine89.h

AnimateAnObject
engine@0000:

	move.w	#1024,ZFactor
	
	move.l  #$F00+8,-(a7)         ; $F00
	jsr     _ROM_CALL_090           ; Offset : $032E : 4EB9 0000 0000 
	addq    #4,a7 
	move.w  d0,vscr_h               ; Offset : $0338 : 33C0 0000 105C
	bne	RAMOk
	rts

RAMOk
	DEREF   d0,a6

	move.l	a6,a0	

	move.w	#ClrBuffer,d0		;Clear BufferPlan1
RepClrBuf:
	clr.l	(a6)+
	dbf	d0,RepClrBuf
	bsr	ClrScr	

	move.l	a0,BufferPlan1

        bsr     gray
	tst.w	d0
	beq	Remove_vscr_h	

	clr.b	color

	add.l	#OffSet,BufferPlan1
        move.l  plane0,a6
	adda.l	#OffSet,a6
	move.l	a6,vscr
	move.l  a6,fglib@0F00      		 ;Video ptr
	adda.l	#$F00,a6
	move.l	a6,vscr2

 	

	clr.w	frames			; Offset : $0354 : 4279 0000 1062 
;	clr.w	TotalTri

	DrawStr


;************ Allocating memory for calculated points ***********
	clr.l	d0
	move.w	Object_NbPoints,d0
	add.w	#1,d0		;!!!
	lsl.w	#2,d0
	move.l	d0,-(a7)
	jsr	doorsos::HeapAlloc
	addq	#4,a7
	move.w	d0,HandlePts
	DEREF	d0,a0
	move.l	a0,HandlePtsPtr

;************ Allocating memory for Depth buffer ***********
	clr.l	d0
	move.w	Object_NbFaces,d0
	add.w	#10,d0		;!!!
	lsl.w	#1,d0
	move.l	d0,-(a7)
	jsr	doorsos::HeapAlloc
	addq	#4,a7
	move.w	d0,HandleZ
	DEREF	d0,a0
	move.l	a0,HandleZPtr

;************ Allocating memory for sorted points ***********
	clr.l	d0
	move.w	Object_NbFaces,d0
	add.w	#10,d0		;!!!
	lsl.w	#1,d0
	move.l	d0,-(a7)
	jsr	doorsos::HeapAlloc
	addq	#4,a7
	move.w	d0,HandleSorted
	DEREF	d0,a0
	move.l	a0,HandleSortedPtr


	move.b	#0,Bordure
	move.b	#0,Filled

;	move.l	#$2A8,d0
;RepClrV:
;	clr.l	(a6)+
;	dbf	d0,RepClrV

	move.l	#$19202200,vx 
;	clr.l	vx
	move.w	#$1,modecnt
ChangeMode:
	tst.b	modecnt
	bne.w	RepRotate
	lea	modes,a0
	bchg	#$0,control
	bne.w	NoAdd
	adda.w	#$5,a0
NoAdd:
	move.b	#$5,modecnt
RepRotate:
	bsr	DrawObject
NoTouche
	tst.b	modecnt
	beq.w	NoCntDec
	subq.b	#$1,modecnt
NoCntDec:
	tst.b	control			; Offset : $03BA : 4A39 0000 106F 
	bne.w	Manual			; Offset : $03C0 : 6600 0018 
	addq.b	#$5,vx			; Offset : $03C4 : 5839 0000 106A 
	addq.b	#$6,vy			; Offset : $03CA : 5A39 0000 106B 
	addq.b	#$7,vz			; Offset : $03D0 : 5C39 0000 106C 
	dc.w	$6000
	dc.w	IncFrame-*		; bra.w	IncFrame
Manual:					; Offset : $03DA
	move.w	#Getkey1,$600018		; Offset : $03DA : 33FC FFFD 0060 0018 
	nop				; Offset : $03E2 : 4E71 
	nop				; Offset : $03E4 : 4E71 
	nop				; Offset : $03E6 : 4E71 
	nop				; Offset : $03E8 : 4E71 
	nop				; Offset : $03EA : 4E71 
	nop				; Offset : $03EC : 4E71 
	nop
	nop				
	nop			
	nop							 
	move.b	$60001B,d0		; Offset : $03F0 : 1039 0060 001B 
	btst	#Xminus,d0			; Offset : $03F6 : 0800 0005 
	bne.w	Chk2			; Offset : $03FA : 6600 0008 
	subq.b	#$5,vx			; Offset : $03FE : 5B39 0000 106A 
Chk2:					; Offset : $0404
	btst	#Yminus,d0			; Offset : $0404 : 0800 0006 
	bne.w	Chk3			; Offset : $0408 : 6600 0008 
	subq.b	#$5,vy			; Offset : $040C : 5B39 0000 106B 
Chk3:					; Offset : $0412
	btst	#Zminus,d0
	bne.w	Chk4
	subq.b	#$5,vz
Chk4:


	move.w	#Getkey2,$600018		
	nop			
	nop			
	nop			
	nop				
	nop				
	nop			
	nop
	nop				
	nop			
	nop							
	move.b	$60001B,d0		
	btst	#Xplus,d0	
	bne.w	Chk7
	addq.b	#$5,vx
Chk7:
	btst	#Yplus,d0
	bne.w	Chk8
	addq.b	#$5,vy
Chk8:					
	btst	#Zplus,d0
	bne.w	IncFrame
	addq.b	#$5,vz
IncFrame:		
	addq.w	#$1,frames
	


ChkReste:
	move.w	#Getkey3,$600018		
	nop			
	nop			
	nop			
	nop			
	nop			
	nop	
	nop
	nop				
	nop			
	nop							
	move.b	$60001B,d0
	btst	#ZoomIn,d0			; Check for Zoom In
	bne.w	Chk5
	add.w	#64,ZFactor
	bra	Chk6
Chk5:
	btst	#ZoomOut,d0			; Check for Zoom In
	bne.w	Chk6
	tst.w	ZFactor
	ble	Chk6
	sub.w	#64,ZFactor
Chk6:	
	btst	#SwitchMode,d0		
	beq.w	SwitchDispMode		
	btst	#Mode,d0			
	beq.w	ChangeMode		
	btst	#Exit,d0			
	bne.w	RepRotate
	bne	NoTouche



	move.w	HandleZ,-(a7)
	jsr	_ROM_CALL_097
	lea	2(a7),a7

	move.w	HandlePts,-(a7)
	jsr	_ROM_CALL_097
	lea	2(a7),a7

	move.w	HandleSorted,-(a7)
	jsr	_ROM_CALL_097
	lea	2(a7),a7

        bsr     gray2

Remove_vscr_h
        move.w  vscr_h,-(a7)
        jsr     _ROM_CALL_097
        lea     2(a7),a7


	rts			






SwitchDispMode:				; Offset : $04E2
	tst.b	modecnt			; Offset : $04E2 : 4A39 0000 106E 
	bne.w	RepRotate		; Offset : $04E8 : 6600 FEB4 
	addq.b	#$1,dispmode		; Offset : $04EC : 5239 0000 106D 
	cmpi.b	#$3,dispmode		; Offset : $04F2 : 0C39 0003 0000 106D 
	bcs.w	OK			; Offset : $04FA : 6500 0008 
	clr.b	dispmode		; Offset : $04FE : 4239 0000 106D 
OK:					; Offset : $0504
	move.b	#$5,modecnt
	bra	RepRotate

DrawObject:
;	move.l	vscr,a0
;	move.l	vscr2,a1
;	move.w	#$2A8,d0
;RepClr:
;	clr.l	(a0)+
;	clr.l	(a1)+
;	dbf	d0,RepClr


	movem.l	d0-d7/a0-a6,-(sp)
	move.l	a7,save
        move.l  vscr,a7
        adda.l  #2760-28,a7
	movem.l	zeroes,d0-d7/a0-a6	

	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7,-(a7)	; repeated 64 times	;Actually 46 times

        move.l  vscr2,a7
        adda.l  #2760-28,a7

	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7/a0-a6,-(a7)	; repeated 64 times
	movem.l	d0-d7,-(a7)	; repeated 64 times	;Actually 46 times


        move.l	save,a7
        movem.l	(sp)+,d0-d7/a0-a6


	Calc3D
	

	cmpi.b	#$1,dispmode
	beq.w	DrawLine
	cmpi.b	#$0,dispmode
	beq.w	DrawPoints

	CalcAxes3D
;*************************************************
DrawTriangle:
;       bra     NoAxes3
;DrawAxes:
;        lea.l   AxesPts,a1
;        move.w  (a1)+,d0
;        move.w  (a1)+,d1
;        move.w  (a1)+,d2
;        move.w  (a1)+,d3
;;       testClip NoAxes
;        jsr fglib::fline
;NoAxes:
;        move.w  (a1)+,d2
;        move.w  (a1)+,d3
;;       testClip NoAxes2
;        jsr fglib::fline
;NoAxes2:
;        move.w  (a1)+,d2
;        move.w  (a1)+,d3
;;       testClip NoAxes3
;        jsr fglib::fline
;NoAxes3:
;
;         
	include	SortAlgo.asm

	movea.l	vscr,a0
	move.l	HandlePtsPtr,a1
	move.l	HandleSortedPtr,a4
	move.l	Object_Faces,a5
	move.w	Nb_visibles,d7
	subq.w	#1,d7
RepDrawTri:
	clr.l	d2
	clr.l	d3

;	move.l	#0,a2
;	move.l	#0,a3

	move.w	(a4)+,d5
	lsl.w	#4,d5		;3
	lea.l	0(a5,d5.w),a6

	move.w	(a6)+,d5	;8	
	move.w	(a6)+,d6		
	move.w	(a6)+,d4	

        lsl.w   #2,d5           ;10
        lsl.w   #2,d6           
	lsl.w	#2,d4
	move.w	0(a1,d5.w),d0	;18
	move.w	2(a1,d5.w),d1		
	move.w	0(a1,d6.w),d2		
	move.w	2(a1,d6.w),d3		
	move.w	0(a1,d4.w),a2		
	move.w	2(a1,d4.w),a3	
				;====
				;3*8+3*10+6*18 = 162
;	testClip	SkipthisFace

	move.b	9(a6),d5	;color


	cmp.b	color,d5
	beq	SameColor
		
	tst.b	d5
	bne	nop
	SetColorBlack4
	bra	nop2
nop
	cmp.b	#1,d5
	bne	nop0
	SetColorGray2
	bra	nop2
nop0
	cmp.b	#2,d5
	bne	nop1
	SetColorGray1
;	bra	nop2
nop1
;	cmp.b	#3,d5
;	bne	nop2
;	SetColorWhite4
nop2

	move.b	d5,color
SameColor:
        jsr     fglib@0001
SkipthisFace:
	dbf	d7,RepDrawTri	

;	bra	Flip
	
;Flip:					
	lea	FlipOffset,a1
	move.l	vscr2,a3
	move.l	BufferPlan1,a2
;	move.l	#$FFFFFFFF,(a1)
;	move.l	#$FFFFFFFF,(a2)
	move.l	#TriFlipLoop,d0
RepVCopy_:			
	move.l	(a0)+,(a1)+
	move.l	(a3)+,(a2)+
	dbf	d0,RepVCopy_	
;	move.l	#$FFFFFFFF,(a1)+
;	move.l	#$FFFFFFFF,(a2)+

DEBUG	MACRO
	movem.l	d0-d7/a0-a6,-(a7)	
	lea	LCD_MEM+$384,a1
	move.b	vx,d0
	move.l  #0,d1
        move.l  #20,d2
        move.l  #1,d4
	bsr	put_hex
	lea	LCD_MEM+$384,a1
	move.b	vy,d0
	move.l  #1,d1
        move.l  #20,d2
        move.l  #1,d4
	bsr	put_hex
	lea	LCD_MEM+$384,a1
	move.b	vz,d0
	move.l  #2,d1
        move.l  #20,d2
        move.l  #1,d4
	bsr	put_hex
	movem.l	(a7)+,d0-d7/a0-a6
	ENDM


	rts

;*************************************************

DrawLine:
; Calc3D
 move.l		HandlePtsPtr,a1
 move.l		Object_Faces,a2
 move.w  	Object_NbFaces,d7
 lsl.w	#1,d7
 movea.l	vscr,a0	
 move.l         vscr,fglib@0F00       ;Video ptr
; move.w        #128,fglib@0F01               ;nbre of Video lines
 subq	#1,d7
RepDrawLines:
 clr.l	 d5
 clr.l	 d6
 move.w  (a2)+,d5
 move.w  (a2)+,d6
 adda.l	 #4,a2
 lsl.w	 #2,d5
 lsl.w	 #2,d6
 move.w  0(a1,d5),d0
 move.w  2(a1,d5),d1
 move.w  0(a1,d6),d2
 move.w  2(a1,d6),d3

	testClip2

 jsr fglib::fline
SkipthisFace2
 dbra	 d7,RepDrawLines
 bra Flip


;*************************************************
DrawPoints:
;	jsr	Calc3D
;	Calc3D
	move.l	HandlePtsPtr,a1
;       move.w  #128,fglib@0F01               ;nbre of Video lines
	movea.l	vscr,a0				
	move.w	Object_NbPoints,d7			; Offset : $059E : 2E3C 0000 00B3 
RepDrawPoints:				; Offset : $05A4
	move.w	(a1)+,d0		; Offset : $05A4 : 3019 
	move.w	(a1)+,d1		; Offset : $05A6 : 3219 
	move.w	d1,d4			; Offset : $05A8 : 3801 
	move.w	d1,d5			; Offset : $05AA : 3A01 
	lsl.w	#$5,d4			; Offset : $05AC : EB4C 
	lsl.w	#$1,d5			; Offset : $05AE : E34D 
	sub.w	d5,d4			; Offset : $05B0 : 9845 
	move.w	d0,d5			; Offset : $05B2 : 3A00 
	lsr.w	#$3,d5			; Offset : $05B4 : E64D 
	add.w	d5,d4			
	move.w	d0,d5			
	not.w	d5			
	andi.b	#$7,d5			
	
	move.l	a0,a2			;Sort of Cliping
	move.l	a0,a3			;
	add.w	d4,a2			;
	cmp.l	a0,a2			;
	blt	Skip			;
	add.l	#PointClip,a3		;
	cmp.l	a3,a2	 		;
	bgt	Skip			;Sort of Cliping

	bset	d5,(a2)
Skip:
	dbf	d7,RepDrawPoints	
Flip:					
	lea	FlipOffset,a1
	move.l	#NbrLoop,d0
RepVCopy:			
	move.l	(a0)+,(a1)+
	dbf	d0,RepVCopy	
	
	rts
;***********************************************************

ClrScr:
	lea	LCD_MEM,a1		
	move.l	#$3BF,d0
ClrLoop:
	clr.l	(a1)+
	dbf	d0,ClrLoop
	rts

;***********************************************************

sintable:
 incbin "sint.bin"

engine@0003:
Object_Points	dc.l	0

engine@0004:
Object_Faces	dc.l	0


zeroes          dcb.l   15,0
save		dc.l	0


vscr		 dc.l 0
vscr2		 dc.l 0
HandlePtsPtr	dc.l	0
HandleZPtr	dc.l	0
HandleSortedPtr	dc.l	0
BufferPlan1	dc.l	0


vscr_h	dc.w 0
HandlePts	dc.w	0
HandleZ		dc.w	0
HandleSorted	dc.w	0

frames	dc.w 0
loop	dc.w	0
Nb_visibles	dc.w	0
;NbPoints	dc.w	0
;NbFaces	dc.w	0

engine@0001:
Object_NbPoints	dc.w	0

engine@0002:
Object_NbFaces	dc.w	0

ZFactor	dc.w	0

;TotalTri	dc.w	0

AxesPts		ds.w	8

Axes_Points	dc.w	0,0,0
		dc.w	0,0,30	; k->
		dc.w	0,20,0	; j->
		dc.w	40,0,0	; i->

str	 ds.b 6
strend

vx	 dc.b 0
vy	 dc.b 0
vz	 dc.b 0
dispmode dc.b 0

modecnt  dc.b 0
control  dc.b 0

	EVEN

modes	 	dc.b "Demo",0,"User   ",0
	EVEN
AInfo   	dc.b    "   DBA Engine Demo - Powered by FgLib   ",0
	EVEN

	InfoStr


color		dc.b	0

	EVEN
_comment	 Version
	dc.b	"Kty from DBA - 2000 -"

	EVEN
Filled	dc.b	0
Bordure	dc.b	0
;IsClipOk	dc.b	0

Surface		;32x32

	dc.w	5,0,5,2,5,6,0,4
	dc.w	 0,5,0,5,0,1,2,8
	dc.w	5,0,5,0,2,0,4,8
	dc.w	 0,5,0,5,0,3,6,2
	dc.w	5,0,5,0,5,4,5,8
	dc.w	 0,5,0,5,0,1,8,3



	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0
	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0
	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0

	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0
	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0
	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0

	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0
	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0
	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0
	
	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0
	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0
	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0

	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0
	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0
	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0

	dc.b	5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,5
	dc.b	0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,0


	end

